
/* cpu.h
 * ВК-6 v0.30
 * (c) Васильев И.В., Москва, 5 марта 2010 г.
 *
 * Программа распространяется под лицензией GNU GPL v3.
 */

typedef long double real;
typedef void function(void);

#define STR_VERSION "0.30"
#define NUM_VERSION (0.30)


/* регистры стека и память ВК-6 */
real RX, RY, RZ, RT, RX1;
unsigned char bProg[10000];


/* состояние ВК-6, переменные */
int flgError, flgGrad, iPC, iMode, iStateInput;
int flgDisplay; /* сбросьте, если не требуется новый вывод экрана */


/* проверка RX на переполнение и машинный нуль */
int Guard(void), Guard12(void);


/* точки останова               */
int iBreakAdr[10], nBreaks;


/* команды ВК-6 для исполнения в автоматическом режиме */
void Digit(int x), Tochka(void), Negate(void), EE(void);
void Enter(void), Cx(void), FR(void), XCHG(void), FANS(void);
void Plus(void), Minus(void), Multiply(void), Divide(void);
void FPI(void), F1X(void), Flg(void), Fln(void);
void F10X(void), FEXP(void), FSQRT(void), FX2(void), FXY(void);
void Fsin(void), Fcos(void), Ftg(void);
void Farcsin(void), Farccos(void), Farctg(void);
void KRAN(void), KPRGM(void), KNOP(void), KMINUS(void), KDIV(void);
void KABS(void), KSGN(void), Kmax(void), KINT(void), KFRAC(void);
void KMD(void), KMSD(void), KDMS(void), KDM(void);
void KAND(void), KOR(void), KXOR(void), KNOT(void);
void B0(void), GOTO(int bcd, int iPCref), PGOTO(int bcd1, int bcd2);
void KGOTO(int r), PKGOTO(int bcd);
void KSCR(void), KGRPH(void);


/* управление ВК-6 */
void TurnOn(function *f1, function *f2), TurnOff(void);
void Step(int flgSilent), Run(int flgSilent), IntoAVT(int flgE);
void GRAD(void);


