
/* os.c
 * ВК-6 v0.30
 * (c) Васильев И.В., Москва, 11 марта 2010 г.
 *
 * Программа распространяется под лицензией GNU GPL v3.
 *
 * Системно-зависимые функции.  Вариант для Гну-Линукс.
 */

#include <sys/time.h>
#include <stdio.h>

static time_t tSeconds;
static struct timeval tv;

void OsAlert(char *sModule, char *sMsg)
/* В данной реализации сообщение идёт на терминал. */
{ printf(" *** %s: %s\n", sModule, sMsg);
}


void OsInit(void)
{ if (gettimeofday(&tv, NULL))
    OsAlert("os", "Система не поддерживает gettimeofday().");
  else tSeconds = tv.tv_sec;
}


long OsTime(void)
{ gettimeofday(&tv, NULL);
  return (long) ((tv.tv_sec - tSeconds)*100 + (tv.tv_usec+5000)/10000);
}



